<?php
/**
KeyCAPTCHA extension for MediaWiki 1.16.x - 1.18.x

Version: 1.0.0
Author: Mersane, Ltd, www.keycaptcha.com
Email: support@keycaptcha.com
Url: https://www.keycaptcha.com
Copyright (C) 2011-2012 Mersane, Ltd (www.keycaptcha.com). All rights reserved.
License GNU GPL 2.0 (http://www.gnu.org/licenses/gpl-2.0.html)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
	if (!defined('MEDIAWIKI')) {
		exit;
	}	
	/*============================= Settings ========================*/
	global $wgExtensionFunctions, $wgGroupPermissions;	
	$wgGroupPermissions['*']['skipcaptcha'] = false;
	$wgGroupPermissions['user']['skipcaptcha'] = false;
	$wgGroupPermissions['autoconfirmed']['skipcaptcha'] = false;
	$wgGroupPermissions['bot']['skipcaptcha'] = true;
	$wgGroupPermissions['sysop']['skipcaptcha'] = true;
	$wgGroupPermissions['emailconfirmed']['skipcaptcha'] = false;
	$wgAvailableRights[] = 'skipcaptcha';
	global $ccAllowConfirmedEmail;
	$ccAllowConfirmedEmail = false;	
	$wgCaptchaTriggers = array();
	$wgCaptchaTriggers['edit'] = true;
	$wgCaptchaTriggers['create'] = true;
	$wgCaptchaTriggers['sendemail'] = true;
	$wgCaptchaTriggers['addurl'] = true;
	$wgCaptchaTriggers['createaccount'] = true;
	$wgCaptchaTriggers['badlogin'] = true;
	global $wgCaptchaBadLoginAttempts;
	// To enable KeyCAPTCHA on Login form you should turn on cache in your LocalSettings.php e.g. $wgMainCacheType = CACHE_DB;
	$wgCaptchaBadLoginAttempts = 3;	
	global $wgCaptchaBadLoginExpiration;
	$wgCaptchaBadLoginExpiration = 5 * 60;
	$wgCaptchaWhitelist = false;
	/*========================= End of Settings ======================*/		
	
	$wgKeyCaptchaIP = dirname(__FILE__);
	$wgExtensionMessagesFiles['keyCaptcha'] = dirname( __FILE__ ) . '/keyCaptcha.i18n.php';
	require_once("$wgKeyCaptchaIP/keyCaptchaClass.php");
	class keyCaptcha{
		function captchaTriggers( &$editPage, $action ) {
			global $wgCaptchaTriggers;
			return ( !empty( $wgCaptchaTriggers[$action] ) );
		}
	
		function filterLink( $url ) {
			global $wgCaptchaWhitelist;
			$source = wfMsgForContent( 'captcha-addurl-whitelist' );

			$whitelist = wfEmptyMsg( 'captcha-addurl-whitelist', $source )
				? false
				: $this->buildRegexes( explode( "\n", $source ) );
	
			$cwl = $wgCaptchaWhitelist !== false ? preg_match( $wgCaptchaWhitelist, $url ) : false;
			$wl  = $whitelist          !== false ? preg_match( $whitelist, $url )          : false;
			return !( $cwl || $wl );
		}
	
		function loadText( $editPage, $section ) {
			$rev = Revision::newFromTitle( $editPage->mTitle );
			if ( is_null( $rev ) ) {
				return "";
			} else {
				$text = $rev->getText();
				if ( $section != '' ) {
					global $wgParser;
					return $wgParser->getSection( $text, $section );
				} else {
					return $text;
				}
			}
		}
	
		function findLinks( &$editpage, $text ) {
			global $wgParser, $wgUser;
	
			$options = new ParserOptions();
			$text = $wgParser->preSaveTransform( $text, $editpage->mTitle, $wgUser, $options );
			$out = $wgParser->parse( $text, $editpage->mTitle, $options );
			return array_keys( $out->getExternalLinks() );
		}
	
		function getForm($from=0){																	
			global $wgKeyCaptchaPrivateKey, $wgKeyCaptchaID;
			$keycaptchacode = "
			<!-- KeyCAPTCHA code (www.keycaptcha.com)-->
				<script language=\"JavaScript\">
					var s_s_c_user_id = '".$wgKeyCaptchaID."';
					var s_s_c_session_id = '#KC_SESSION_ID#';
					var s_s_c_captcha_field_id = 'hash';". (($from==0)?
					"var s_s_c_submit_button_id = 'wpSave,wpLoginAttempt,wpCreateaccount';
					document.s_s_c_without_submit_search = true;":
					"var s_s_c_submit_button_id = 'sbutton-#-r';").
					"var s_s_c_web_server_sign = '#KC_WSIGN#';
					var s_s_c_web_server_sign2 = '#KC_WSIGN2#';
				</script>
				<script language=JavaScript src=\"http://backs.keycaptcha.com/swfs/cap.js\"></script>
			<!-- end of KeyCAPTCHA code-->";
			$kc_o = new KeyCAPTCHA_CLASS($wgKeyCaptchaPrivateKey ,  $keycaptchacode );
			$tmpl = '<input type=hidden value="1" id="hash" name="hash" />##keycaptchacode##'.
			 	'<noscript>You should turn on JavaScript on your browser. After that please reload the page.'.
			 	'Otherwise you won&#039;t be able to post any information on this site.</noscript>';
			$kc_js = $kc_o->render_js();
			$stout = str_replace( '##keycaptchacode##', $kc_js, $tmpl );
			return $stout;
		}

		function getMessage($action){ 			
			$name = 'keycaptcha-' . $action;
			$text = wfMsg( $name );
			return wfEmptyMsg( $name, $text ) ? wfMsg( 'keycaptcha-edit' ) : $text;		
		}

		function checkCaptcha(){
			global $wgKeyCaptchaPrivateKey, $wgKeyCaptchaPrivateKey;
			$kc_o = new KeyCAPTCHA_CLASS( $wgKeyCaptchaPrivateKey );		
			$kc_field  = $_POST['hash'];
			if (!$kc_o->check_result($kc_field)) {
			    $this->error = 'keycaptcha_wrong_solution';
				return false;
			}
			return true;		
		}

		function shouldCheck( &$editPage, $newtext, $section, $merged = false){
			$this->trigger = '';
			$title = $editPage->mArticle->getTitle();
			global $wgUser;
			if ( $wgUser->isAllowed( 'skipcaptcha' ) ) {
				wfDebug( "keyCaptcha: user group allows skipping captcha\n" );
				return false;
			}
			global $wgEmailAuthentication, $ccAllowConfirmedEmail;
			if ( $wgEmailAuthentication && $ccAllowConfirmedEmail &&$wgUser->isEmailConfirmed() ) {
				wfDebug( "keyCaptcha: user has confirmed mail, skipping captcha\n" );
				return false;
			}
 			if ( $this->captchaTriggers( $editPage, 'edit' ) ) {
				global $wgUser;
				$this->trigger = sprintf( "edit trigger by '%s' at [[%s]]",
					$wgUser->getName(),
					$title->getPrefixedText() );
				$this->action = 'edit';
				wfDebug( "keyCaptcha: checking all edits...\n" );
				return true;
			}
			if ( $this->captchaTriggers( $editPage, 'create' )  && !$editPage->mTitle->exists() ) {
				global $wgUser;
				$this->trigger = sprintf( "Create trigger by '%s' at [[%s]]",
					$wgUser->getName(),
					$title->getPrefixedText() );
				$this->action = 'create';
				wfDebug( "keyCaptcha: checking on page creation...\n" );
				return true;
			}
			if ( $this->captchaTriggers( $editPage, 'addurl' ) ) {
			if ( $merged ) {
					$oldLinks = $this->getLinksFromTracker( $title );
					$editInfo = $editPage->mArticle->prepareTextForEdit( $newtext );
					$newLinks = array_keys( $editInfo->output->getExternalLinks() );
				} else {
					$oldtext = $this->loadText( $editPage, $section );
					$oldLinks = $this->findLinks( $editPage, $oldtext );
					$newLinks = $this->findLinks( $editPage, $newtext );
				}
	
				$unknownLinks = array_filter( $newLinks, array( &$this, 'filterLink' ) );
				$addedLinks = array_diff( $unknownLinks, $oldLinks );
				$numLinks = count( $addedLinks );
				if ( $numLinks > 0 ) {
					global $wgUser;
					$this->trigger = sprintf( "%dx url trigger by '%s' at [[%s]]: %s",
						$numLinks,
						$wgUser->getName(),
						$title->getPrefixedText(),
						implode( ", ", $addedLinks ) );
					$this->action = 'addurl';
					return true;
				}
			}
			return false;
		}

		function checkEdit( $editPage, $newtext, $section, $merged = false ){
			if( $this->shouldCheck( $editPage, $newtext, $section ) ) {
				if (!isset($_POST['hash'])) {
						$editPage->showEditForm( array( &$this, 'editCallback' ) );
						return false;
				}
				if( $this->checkCaptcha() ) {
						return true;
				} else {
						$editPage->showEditForm( array( &$this, 'editCallback' ) );
						return false;
				}
			} else {
				wfDebug( "keyCaptcha: no need to show captcha.\n" );
				return true;
			}		
		}

		function checkEditMerged( $editPage, $newtext ){
			return $this->checkEdit( $editPage, $newtext, false, true );
		}

		function checkEditAPI( $editPage, $newtext, &$resultArr ){
			if ( !$this->doCheckEdit( $editPage, $newtext, false, false ) ) {			
				$this->addCaptchaAPI( $resultArr );
				return false;
			}
			return true;
		}

		function injectUserCreate( &$template ){
			global $wgCaptchaTriggers, $wgOut, $wgUser;
			
			echo $wgCaptchaTriggers['createaccount']==false;
			if ( $wgCaptchaTriggers['createaccount'] ) {
				if ( $wgUser->isAllowed( 'skipcaptcha' ) ) {
					wfDebug( "keyCaptcha: user group allows skipping captcha on account creation\n" );
					return true;
				}
				
				$template->set( 'header',
					"<div class='captcha'>" .
					$wgOut->parse( $this->getMessage( 'createaccount' ) ) .
					$this->getForm() .
					"</div>\n" );
					
			}	
			return true;		
		}

		function checkUserCreate( $u, &$message ){
			global $wgCaptchaTriggers, $wgUser;
			if ( $wgCaptchaTriggers['createaccount'] ) {
				if ( $wgUser->isAllowed( 'skipcaptcha' ) ) {
					wfDebug( "keyCaptcha: user group allows skipping captcha on account creation\n" );
					return true;
				}
			}
			if ( !$this->checkCaptcha() ) {
				$message .= $this->getMessage('createaccount-fail');
				return false;
			}			
			return true;
		}

		function injectUserLogin( &$template ){
			if ( $this->isBadLoginTriggered() ) {
				global $wgOut;
				$template->set( 'header',
					"<div class='captcha'>" .
					$wgOut->parse( $this->getMessage( 'badlogin' ) ) .
					$this->getForm() .
					"</div>\n" );
			}
			return true;
		}

		function checkUserLogin( $u, $pass, &$retval ){
			if ( $this->isBadLoginTriggered() ) {
				$this->trigger = "post-badlogin login '" . $u->getName() . "'";
				if ( !$this->checkCaptcha() ) {
					$retval = LoginForm::WRONG_PASS;
					return false;
				}
			}
			return true;
		}

		function injectEmailUser( $form ){
			global $wgCaptchaTriggers, $wgOut, $wgUser;
			if ( $wgCaptchaTriggers['sendemail'] ) {			
				if ( $wgUser->isAllowed( 'skipcaptcha' ) ) {
					wfDebug( "keyCaptcha: user group allows skipping captcha on email sending\n" );
					return true;
				}
				$form->addFooterText( 
					"<div class='captcha'>" .
					$wgOut->parse( $this->getMessage( 'sendemail' ) ) .
					$this->getForm(1) .
					"</div>\n" );
			}
			return true;
		}

		function checkEmailUser( $from, $to, $subject, $text, $error ){
			global $wgCaptchaTriggers, $wgUser;
			if ( $wgCaptchaTriggers['sendemail'] ) {

				if ( $wgUser->isAllowed( 'skipcaptcha' ) ) {
					wfDebug( "keyCaptcha: user group allows skipping captcha on email sending\n" );
					return true;
				}
				if ( defined( 'MW_API' ) ) {
					$error = wfMsg( 'captcha-disabledinapi' );
					return false;
				}
				$this->trigger = "{$wgUser->getName()} sending email";
				if ( !$this->checkCaptcha() ) {
					$error = wfMsg( 'captcha-sendemail-fail' );
					return false;
				}
			}
			return true;
		}

		function isBadLoginTriggered(){
			global $wgMemc, $wgCaptchaBadLoginAttempts;
			return intval( $wgMemc->get( $this->badLoginKey() ) ) >= $wgCaptchaBadLoginAttempts;
		}

		function badLoginKey() {
			return wfMemcKey( 'captcha', 'badlogin', 'ip', wfGetIP() );
		}
	
		function triggerUserLogin( $user, $password, $retval ) {
	
			global $wgCaptchaTriggers, $wgCaptchaBadLoginExpiration, $wgMemc;
			if ( $retval == LoginForm::WRONG_PASS && $wgCaptchaTriggers['badlogin'] ) {
				$key = $this->badLoginKey();			
				$count = $wgMemc->get( $key );			
				
				if ( !$count ) {
					$wgMemc->add( $key, 0, $wgCaptchaBadLoginExpiration );
				}
				$count = $wgMemc->incr( $key );
			}
			return true;
		}

		private function doCheckEdit( $editPage, $newtext, $section, $merged = false ) {
			if ( $this->shouldCheck( $editPage, $newtext, $section, $merged ) ) {
				if ( $this->checkCaptcha() ) {
					return true;
				} else {
					return false;
				}
			} else {
				wfDebug( "keyCaptcha: no need to show captcha.\n" );
				return true;
			}
		}

		function editCallback( &$out ) {
			$out->addWikiText( $this->getMessage( $this->action ) );
			$out->addHTML( $this->getForm() );
		}	
	}

	$wgAutoloadClasses['keyCaptchaHooks'] = "$wgKeyCaptchaIP/keyCaptchaHooks.php";
	if ( defined( 'MW_SUPPORTS_EDITFILTERMERGED' ) ) {
		$wgHooks['EditFilterMerged'][] = 'keyCaptchaHooks::checkEditMerged';
	} else {
		$wgHooks['EditFilter'][] = 'keyCaptchaHooks::checkEdit';
	}
	$wgHooks['UserCreateForm'][] = 'keyCaptchaHooks::injectUserCreate';
	$wgHooks['AbortNewAccount'][] = 'keyCaptchaHooks::checkUserCreate';
	$wgHooks['LoginAuthenticateAudit'][] = 'keyCaptchaHooks::triggerUserLogin';
	$wgHooks['UserLoginForm'][] = 'keyCaptchaHooks::injectUserLogin';
	$wgHooks['AbortLogin'][] = 'keyCaptchaHooks::checkUserLogin';
	$wgHooks['EmailUserForm'][] = 'keyCaptchaHooks::injectEmailUser';
	$wgHooks['EmailUser'][] = 'keyCaptchaHooks::checkEmailUser';
	$wgHooks['APIEditBeforeSave'][] = 'keyCaptchaHooks::checkEditAPI';
